{MultiTask
 ---------
(C) 1995, 1996 by A. von Wyss

Preemptives Multitasking innerhalb von DOS-Programmen. Prozesse mit "briger"
Rechenzeit knnen diese mit SWITCH abgeben. Der Fehlerstatus IOERROR wird fr
jeden Task separat verwaltet. So knnen Taskbergreifende Fehler bei Dateizu-
griffen vermieden werden.
Die Stackberprfung darf NIE eingeschaltet sein!

Wechselfreuenz: 100 Hz (hher, wenn SWITCH Task wechselt)
Zeitscheiben:    10 ms (krzer, wenn SWITCH Task wechselt)

Luft unter Real Mode und Protected Mode.

Verion: 2.10
Revision: 960425}

{$A+,B-,D-,E-,F-,G+,I-,L-,N-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$C MOVEABLE,PRELOAD,PERMANENT}

{define separate_io}
{Wenn SEPARATE_IO bei der compilierung aktiviert ist, so erhlt jeder Task
eine eigene INPUT und OUTPUT. Allerdings wird durch das Kopieren des Inhalts
die Switch-Zeit um einieges erhht. Darum wird besser im Task eine Textdatei
auf dem Bildschirm separat geffnet:
	assigncrt(textin);
	reset(textin);
	assigncrt(textout);
	rewrite(textout);
oder ohne CRT-Unit:
	assign(textin,'');
	reset(textin);
	assign(textout,'');
	rewrite(textout);}

unit multitask;

interface
uses dos;

type
	ttaskname=string[15];
	pstack=pointer;
	ttaskproc=procedure(var param);
	pmessage=^tmessage;
	ptask=^ttask;
	ttask=object
		name: ttaskname;
		next: ptask;
		getmsg: wordbool;
		function message(acommand: word; ainfoptr: pointer): boolean;
		function createmessage(acommand: word): pmessage;
	private
		msg: pmessage;
		stack: pstack;
		stacksize: word;
		_ss: word;
		_sp: longint;
{$ifdef separate_io}
		myinput,myoutput: text;
{$endif}
	end;
	tmessage=record
		sender: ptask;
		next: pmessage;
		case command: word of
		0: (infoptr: pointer);
		1: (x,y,k: word);
		2: (key: char; scancode: byte);
	end;

const
	hexchars: array[0..15] of char='0123456789ABCDEF';
	main: ttask=(
		name: 'Main';
		next: nil;
		getmsg: true;
		msg: nil;
		stack: nil;
		stacksize: 0;
		_ss: 0;
		_sp: 0);

var
	task: ptask;
	timer: longint;
	tasks: word;
	focusedtask: ptask;

{Task starten, suchen oder beenden}
procedure newtask(const aname: namestr; astacksize: word; proc: ttaskproc; param: pointer);
function findtask(const aname: namestr): ptask;
procedure endtask;
{Interrupts an/abschalten}
procedure swapvectors;
{Taskkontrolle}
procedure switch;
procedure forbid;
procedure permit;
{Warten, mit Taskswitching}
procedure delay(ms: longint);
{Messageverwaltung}
function hasmessage: boolean;
function waitmessage: pmessage;
function message: pmessage;
procedure broadcastmessage(acommand: word; ainfoptr: pointer);
procedure clearmessage;
{Anderes}
procedure hexptr(var s: string; p: pointer);

implementation
{Durchgehende Benutzung von 32-Bit Befehlen. Dies wird normalerweise durch ein
$66-Byte vor dem Befehl erreicht. Damit werden WORD -> DWORD und BYTE -> WORD.
Das Sichern von FS und GS geschieht mit den folgenden OPCODES:
0F A0: push  fs
0F A8: push  gs
0F A1: pop   fs
0F A9: pop   gs}

const
	calloldcnt: word=2;
	null: byte=0;

var
	old8,old9,old16,oldexit: pointer;
	callold8: word;
	indos: ^byte;
	enabled: boolean;
	switchok: word;

function ttask.message(acommand: word; ainfoptr: pointer): boolean;
var
	amsg: pmessage;
begin
	forbid;
	amsg:=createmessage(acommand);
	if amsg=nil then
		message:=false
	else begin
		message:=true;
		amsg^.infoptr:=ainfoptr;
	end;
	permit;
end;

function ttask.createmessage(acommand: word): pmessage;
var
	amsg: pmessage;
begin
	if (@self=nil) or (not getmsg) then begin
		createmessage:=nil;
		exit;
	end;
	forbid; {Unfertige Messages drfen nicht empfangen werden => Switchstopp!}
	if msg<>nil then begin
		amsg:=msg;
		while amsg^.next<>nil do
			amsg:=amsg^.next;
		new(amsg^.next);
		amsg:=amsg^.next;
	end else begin
		new(amsg);
		msg:=amsg;
	end;
	with amsg^ do begin
		command:=acommand;
		sender:=task;
		next:=nil;
	end;
{	writeln('MSG: ',task^.name,' -> ',name); {Zum debuggen...}
	permit;
	createmessage:=amsg;
end;

function hasmessage: boolean; assembler;
asm
			les	di,[task]
 db $66; mov	ax,word ptr es:[di+ttask.msg]
 db $66; or 	ax,ax
			jz 	@endasm
			mov	ax,true
@endasm:
end;

function waitmessage: pmessage; assembler;
asm
			les	di,[task]
@loop:	call	[switch]
 db $66; mov	ax,word ptr es:[di+ttask.msg]
 db $66; or 	ax,ax
			jz 	@loop
@message:
 db $66; ror	ax,16
			mov	dx,ax
 db $66; shr	ax,16
end;

function message: pmessage; assembler;
asm
			les	di,[task]
 db $66; mov	ax,word ptr es:[di+ttask.msg]
 db $66; ror	ax,16
			mov	dx,ax
 db $66; shr	ax,16
end;

procedure broadcastmessage(acommand: word; ainfoptr: pointer);
var
	atask: ptask;
begin
	atask:=task;
	repeat
		atask^.message(acommand,ainfoptr);
		atask:=atask^.next;
	until atask=task;
end;

procedure clearmessage;
var
	amsg: pmessage;
begin
	with task^ do begin
		if msg=nil then
			exit;
		forbid; {Vernderung des MSG-Zeigers => Switchstopp!}
		amsg:=msg;
		msg:=msg^.next;
		dispose(amsg);
		permit;
	end;
end;

procedure forbid; assembler;
asm
			inc	[switchok]
end;

procedure permit; assembler;
asm
			dec	[switchok]
			cmp [switchok],-1
			jne	@endasm
			mov	[switchok],0
@endasm:
end;

function findtask(const aname: namestr): ptask;
var
	act: ptask;
begin
	act:=task;
	repeat
		if act^.name=aname then begin
			findtask:=act;
			exit;
		end;
		act:=act^.next;
	until act=task;
	findtask:=nil;
end;

{TASK AUFBAUEN UND STARTEN}
procedure newtask(const aname: namestr; astacksize: word; proc: ttaskproc; param: pointer);
var
	mytask: ptask;
begin
	inc(switchok);
	mytask:=task^.next;
	new(task^.next);
	task^.next^.next:=mytask;
	mytask:=task^.next;
	with mytask^ do begin
		name:=aname;
		stacksize:=astacksize;
		getmem(stack,astacksize);
		getmsg:=true;
		_ss:=seg(stack^);
		_sp:=ofs(stack^)+astacksize;
{$ifdef separate_io}
		assign(myinput,'');
		reset(myinput);
		assign(myoutput,'');
		rewrite(myoutput);
{$endif}
		msg:=nil;
	end;
	asm
				cld
				cli
				inc	[tasks]
	db $66;	mov	bx,word ptr [param]{EBX nicht verndern...}
				les	di,[task]
				mov	es:[di+ttask._ss],ss
	db $66;	mov	word ptr es:[di+ttask._sp],sp
	db $66;	mov	dx,word ptr [proc]
				les	di,[mytask]
				mov	ss,es:[di+ttask._ss]
	db $66;	mov	sp,word ptr es:[di+ttask._sp]
	db $66;	xor	ax,ax
	db $66;	push	bx                 {...da es PARAM ist (bzw. war)!}
				push	cs					{=ENDTASK-Segment}
				push	offset endtask	{=ENDTASK-Offset}
				pushf						{=IRET-Flags}
				pop bx
				or bx,$200      {Setzen des Interrupt-Flags!}
				push bx
	db $66;	push	dx			      {=IRET-Adresse}
				push	ds					{= DS=DS}
	db $66;	push	ax		 			{=EAX= 0}
	db $66;	push	ax		 			{=EBX= 0}
	db $66;	push	ax			 		{=ECX= 0}
	db $66;	push	ax		 			{=EDX= 0}
	db $66;	push	ax		 			{=ESI= 0}
	db $66;	push	ax			 		{=EDI= 0}
	db $66;	push	ax			 		{=EBP= 0}
				push	ax 				{= ES= 0}
				push	ax 				{= FS= 0}
				push	ax 				{= GS= 0}
				push	ax 				{=INOUTRES=0}
				push	ax 				{=DOSERROR=0}
	db $66;	mov	word ptr es:[di+ttask._sp],sp
				les	di,[task]
				mov	ss,es:[di+ttask._ss]
	db $66;	mov	sp,word ptr es:[di+ttask._sp]
				sti
	end;
	dec(switchok);
	switch;
end;

procedure freetask(mytask: ptask); {Speicher freigeben (FREEMEM/DISPOSE)}
var
	buf: pmessage;
begin
	with mytask^ do begin
		freemem(stack,stacksize);
		while msg<>nil do begin
			buf:=msg;
			msg:=msg^.next;
			dispose(buf);
		end;
	end;
	dispose(mytask);
end;

procedure endtask;
var
	mytask: ptask;
begin
	if task=@main then
		halt(0);
	forbid;
	while hasmessage do
		clearmessage;
	asm
		cli
	end;
	mytask:=task;
	while mytask^.next<>task do
		mytask:=mytask^.next;
	mytask^.next:=task^.next;
	mytask:=task;
	task:=task^.next;
	if focusedtask=mytask then
		focusedtask:=@main;
	permit;
	asm {Stack wird nicht mehr gltig sein, nachdem er freigegeben wird!}
				cld
	 db $66;	mov	ax,word ptr [mytask]
{$ifdef separate_io}
				mov	dx,ds
				mov	es,dx
				lds	si,[task]
				mov	ss,ds:[si+ttask._ss]
	 db $66;	mov	sp,word ptr ds:[si+ttask._sp]
				mov	cx,type textrec*2/4
				mov	di,offset input
				mov	bx,si
				add	si,ttask.myinput
	 db $66;	rep	movsw
				mov	ds,dx
{$else}
				les	di,[task]
				mov	ss,es:[di+ttask._ss]
	 db $66;	mov	sp,word ptr es:[di+ttask._sp]
{$endif}
	 db $66;	push	ax
				call	[freetask]
				dec	[tasks]
				pop	[doserror]
				pop	[inoutres]
	db $f,$a9{pop	gs}
	db $f,$a1{pop	fs}
				pop	es
	 db $66;	pop	bp
	 db $66;	pop	di
	 db $66;	pop	si
	 db $66;	pop	dx
	 db $66;	pop	cx
			mov bx,sp
			or word ptr ss:[bx+14],$200 {Interrupt flag fr IRET}
	 db $66;	pop	bx
	 db $66;	pop	ax
				pop	ds
				sti
				wait
				iret
	end;
end;

{NEXTTASK: Flags+FSeg+FOfs+DS+EAX auf dem Stack, DS=SEG @DATA!}
{$ifdef separate_io}
procedure nexttask; assembler;
asm
			inc	[switchok]
 db $66;	push bx
 db $66;	push cx
 db $66;	push dx
 db $66;	push si
 db $66;	push di
 db $66;	push bp
			push	es
db $f,$a0{push	fs}
db $f,$a8{push	gs}
			push  [inoutres]
			push	[doserror]
			cld
			les	di,[task]
			mov	es:[di+ttask._ss],ss
 db $66;	mov	word ptr es:[di+ttask._sp],sp
			mov	cx,type textrec*2/4
			mov	si,offset input
			mov	bx,di
			add	di,ttask.myinput
 db $66;	rep	movsw
 db $66;	mov	ax,word ptr es:[bx+ttask.next]
 db $66;	mov	word ptr [task],ax
			mov	dx,ds
			lds	si,[task]
			mov	es,dx
			cli
			mov	ss,ds:[si+ttask._ss]
 db $66;	mov	sp,word ptr ds:[si+ttask._sp]
			sti
			mov	cx,type textrec*2/4
			mov	di,offset input
			add	si,ttask.myinput
 db $66;	rep	movsw
			mov	ds,dx
			pop	[doserror]
			pop	[inoutres]
db $f,$a9{pop	gs}
db $f,$a1{pop	fs}
			pop	es
 db $66;	pop	bp
 db $66;	pop	di
 db $66;	pop	si
 db $66;	pop	dx
 db $66;	pop	cx
			mov bx,sp
			or word ptr ss:[bx+14],$200 {Interrupt flag fr IRET}
 db $66;	pop	bx
 db $66;	pop	ax
			dec	[switchok]
			pop	ds
			wait
			iret
end;
{$else}
procedure nexttask; assembler;
asm
			cli
 db $66;	push bx
 db $66;	push cx
 db $66;	push dx
 db $66;	push si
 db $66;	push di
 db $66;	push bp
			push	es
db $f,$a0{push	fs}
db $f,$a8{push	gs}
			push  [inoutres]
			push	[doserror]
			les	di,[task]
			mov	es:[di+ttask._ss],ss
 db $66;	mov	word ptr es:[di+ttask._sp],sp
 db $66;	mov	ax,word ptr es:[di+ttask.next]
 db $66;	mov	word ptr [task],ax
			les	di,[task]
			mov	ss,es:[di+ttask._ss]
 db $66;	mov	sp,word ptr es:[di+ttask._sp]
			pop	[doserror]
			pop	[inoutres]
db $f,$a9{pop	gs}
db $f,$a1{pop	fs}
			pop	es
 db $66;	pop	bp
 db $66;	pop	di
 db $66;	pop	si
 db $66;	pop	dx
 db $66;	pop	cx
			mov bx,sp
			or word ptr ss:[bx+14],$200 {Interrupt flag fr IRET}
 db $66;	pop	bx
 db $66;	pop	ax
			pop	ds
			sti
			wait
			iret
end;
{$endif}

{Bestimmte Zeit warten, hochoptimiert, jedoch nur 1/100 s genau (TIMER-Variable)!}
procedure delay(ms: longint); assembler;
asm
 db $66;	mov	ax,word ptr [ms]
 db $66;	add	ax,word ptr [timer]
@loop:
			call	[switch]
 db $66;	cmp	ax,word ptr [timer]
			jge	@loop
@end:
end;

{Simulation eines INT8, ohne BIOS-Aufruf}
procedure switch; assembler;
asm
			cmp	[enabled],true
			jne	@quit
			cmp	[switchok],0
			jne	@quit
			pushf
			push	cs
			push	offset	@quit
			push	ds
 db $66;	push	ax
			jmp	[nexttask]
@quit:
end;

{Neue Timerfunktion
>
Switchen, wenn DOS nicht aktiv und SWITCHOK=0; regelmssig das BIOS aufrufen.}
procedure new8; far; assembler;
asm
			push	ds
 db $66;	push	ax
			mov	ax,seg @data
			mov	ds,ax
			cmp	[enabled],true
			je 	@multiint
			pushf
			call	[old8]
			jmp	@endasm
@multiint:
 db $66;	add	word ptr [timer],10
			dec	[callold8]
			jnz	@nocall
			xor	[calloldcnt],3
			mov	ax,[calloldcnt]
			mov	[callold8],ax
			pushf
			call	[old8]
			jmp	@endcall
@nocall:
			mov	al,$20
			out	$20,al
@endcall:
			cmp	[switchok],0
			jne	@endasm
			mov	ax,bx
			lds	bx,[indos]
			cmp	byte ptr ds:[bx],0
			mov	bx,ax
			mov	ax,seg @data
			mov	ds,ax
			jnz	@endasm
			jmp	[nexttask]
@endasm:
			mov ax,bx
			mov bx,sp
			or word ptr ss:[bx+10],$200 {Interrupt flag fr IRET}
			mov bx,ax
 db $66;	pop ax
			pop	ds
			iret
end;

{Neuer Tastaturinterrupthandler/BIOS-Handler
>
Switchen whrend des Tastaturinterrupts (PAUSE!) fhrt sonst zu Abstrzen oder
unerwarteten Effekten.}
procedure new9; far; assembler;
asm
			push	ds
			push	seg @data
			pop	ds
			inc	[switchok]
			pushf
			call	[old9]
			dec	[switchok]
			pop	ds
			iret
end;

{Tastaturbehandlung des BIOS: Beim Zeicheneinlesen switchen, wenn kein Zeichen
vorhanden ist.}
procedure new16; far; assembler;
asm
			push	ds
			push	bx
			mov	bx,seg @data
			mov	ds,bx
			inc	[switchok]
			or 	ah,ah
			je		@readkey
@contread:
			pushf
			call	[old16]
			mov	bx,sp
			pushf
			pop	word ptr ss:[bx+8]
			dec	[switchok]
			pop	bx
			pop	ds
			iret
@readkey:
 db $66;	push	word ptr [indos]
			mov	word ptr [indos],offset null
			mov	word ptr [indos+2],seg null
@readwait:
			mov	ah,1
			pushf
			call	[old16]
			jnz	@doread
			dec	[switchok]
			call	[switch]
			inc	[switchok]
			jmp	@readwait
@doread:
 db $66;	pop	word ptr [indos]
			sub	ah,ah
			jmp	@contread
end;

{Schreibt in S den Pointer als SEGh:OFSh hinein}
procedure hexptr(var s: string; p: pointer); assembler;
asm
			les	di,[s]
			cld
			mov	ax,9
			stosb
 db $66; mov	cx,word ptr [p]
			call	@put
			call	@put
			call	@put
			call	@put
			mov	al,':'
			stosb
			call	@put
			call	@put
			call	@put
			call	@put
			jmp	@endasm
@put:
 db $66; rol cx,4
			mov	bx,cx
			and	bx,$F
			mov	al,byte ptr ds:[hexchars+bx]
			stosb
			retn
@endasm:
end;

procedure newexit; far;
var
	s: pchar;
	t: string[9];
begin
	forbid;
	exitproc:=oldexit;
	setintvec($8,old8);
	setintvec($9,old9);
	setintvec($16,old16);
	port[$43]:=36;
	port[$40]:=0;
	port[$40]:=0;
	port[$20]:=$20;
	if erroraddr<>nil then begin
		asm
			mov	ax,3
			int	$10
		end;
		if exitcode=0 then begin
			writeln('User or Guarddog break in task "',task^.name,'"');
		end else begin
			writeln('A fatal error occured: ');
			case exitcode of
			  1: s:='Invalid function number';
			  2: s:='File not found';
			  3: s:='Path not found';
			  4: s:='Too many open files';
			  5: s:='File access denied';
				6: s:='Invalid file handle';
			 12: s:='Invalid file access code';
			 15: s:='Invalid drive number';
			 16: s:='Cannot remove current directory';
			 17: s:='Cannot rename across drives';
			 18: s:='No more files';
			100: s:='Disk read error';
			101: s:='Disk write error';
			102: s:='File not assigned';
			103: s:='File not open';
			104: s:='File not open for input';
			105: s:='File not open for output';
			106: s:='Invalid numeric format';
			150: s:='Disk is write-protected';
			151: s:='Bad drive request struct length';
			152: s:='Drive not ready';
			154: s:='CRC error in data';
			156: s:='Disk seek error';
			157: s:='Unknown media type';
			158: s:='Sector Not Found';
			159: s:='Printer out of paper';
			160: s:='Device write fault';
			161: s:='Device read fault';
			162: s:='Hardware failure';
			200: s:='Division by zero';
			201: s:='Range check error';
			202: s:='Stack overflow error';
			203: s:='Heap overflow error';
			204: s:='Invalid pointer operation';
			205: s:='Floating point overflow';
			206: s:='Floating point underflow';
			207: s:='Invalid floating point operation';
			208: s:='Overlay manager not installed';
			209: s:='Overlay file read error';
			210: s:='Object not initialized';
			211: s:='Call to abstract method';
			212: s:='Stream registration error';
			213: s:='Collection index out of range';
			214: s:='Collection overflow error';
			215: s:='Arithmetic overflow error';
			216: s:='General protection error';
			217: s:='386 processor expected';
			else s:='Unknown error';
			end;
			hexptr(t,erroraddr);
			writeln('-> ',s,' (',exitcode,') at ',t,' in task "',task^.name,'"');
		end;
		erroraddr:=nil;
		writeln('Running tasks:');
		task:=@main;
		write('-> ');
		repeat
			if length(task^.name)>15 then
				exit;
			write('"',task^.name,'" ');
			task:=task^.next;
		until task=@main;
	end;
end;

const
	timerdiv=11938;

procedure swapvectors;
var
	buf: pointer;
begin
	asm
		cli
		xor	[enabled],1
	end;
	if enabled then begin
		port[$43]:=36;
		port[$40]:=lo(timerdiv);
		port[$40]:=hi(timerdiv);
		port[$20]:=$20;
		permit;
	end else begin
		forbid;
		port[$43]:=36; {HiSpeed-Timer deaktivieren}
		port[$40]:=0;
		port[$40]:=0;
		port[$20]:=$20;
	end;
	asm
		sti
	end;
	dos.swapvectors;
end;

const
	dos_='DOS/';
	unprofessional=' Unprofessional ';
	runtime=' Mode Run-time  Version 2.10';

begin
{$IFDEF DPMI}
	writeln(dos_,'PROT',unprofessional,'Protected',runtime);
{$ELSE}
	writeln(dos_,'REAL',unprofessional,'Real',runtime);
{$ENDIF}
	writeln('Copyright (c) POISON 1994-1996');
	if test8086<2 then
		runerror(217);
{$IFDEF separate_io}
	if ofs(input)+256<>ofs(output) then
		runerror(218);
{$ENDIF}
	switchok:=$FF;
	callold8:=1;
	asm
		mov	ah,$34
		int	$21
		mov	word ptr [indos],bx
		mov	word ptr [indos+2],es
	end;
	getintvec($8,old8);
	getintvec($9,old9);
	getintvec($16,old16);
	enabled:=true;
	main.next:=@main;
	task:=@main;
	focusedtask:=@main;
	oldexit:=exitproc;
	exitproc:=@newexit;
	setintvec($8,@new8);
	setintvec($9,@new9);
{	setintvec($16,@new16);}
	port[$43]:=36;
	port[$40]:=lo(timerdiv);
	port[$40]:=hi(timerdiv);
	port[$20]:=$20;
	switchok:=0;
	tasks:=1;
	switch; {Fertiginitialisieren von MAIN}
end.
